/**
 * WARNING: This is a generated file. Do not modify.
 *
 * Source: buildscripts/idl/idlc.py --include src --base_dir build/mageia --target_arch i386 --header build/mageia/mongo/db/commands/txn_cmds_gen.h --output build/mageia/mongo/db/commands/txn_cmds_gen.cpp src/mongo/db/commands/txn_cmds.idl
 */

#include "mongo/platform/basic.h"

#include "mongo/db/commands/txn_cmds_gen.h"

#include <bitset>
#include <set>

#include "mongo/bson/bsonobjbuilder.h"
#include "mongo/db/command_generic_argument.h"
#include "mongo/db/commands.h"

namespace mongo {

constexpr StringData CommitTransactionOplogObject::kCommitTimestampFieldName;
constexpr StringData CommitTransactionOplogObject::kCommitTransactionFieldName;


CommitTransactionOplogObject::CommitTransactionOplogObject() : _hasCommitTimestamp(false) {
    // Used for initialization only
}
CommitTransactionOplogObject::CommitTransactionOplogObject(mongo::Timestamp commitTimestamp) : _commitTimestamp(std::move(commitTimestamp)), _hasCommitTimestamp(true) {
    // Used for initialization only
}


CommitTransactionOplogObject CommitTransactionOplogObject::parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    CommitTransactionOplogObject object;
    object.parseProtected(ctxt, bsonObject);
    return object;
}
void CommitTransactionOplogObject::parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    std::bitset<2> usedFields;
    const size_t kCommitTransactionBit = 0;
    const size_t kCommitTimestampBit = 1;

    for (const auto& element :bsonObject) {
        const auto fieldName = element.fieldNameStringData();


        if (fieldName == kCommitTransactionFieldName) {
            if (MONGO_likely(ctxt.checkAndAssertType(element, NumberInt))) {
                if (MONGO_unlikely(usedFields[kCommitTransactionBit])) {
                    ctxt.throwDuplicateField(element);
                }

                usedFields.set(kCommitTransactionBit);

                _commitTransaction = element._numberInt();
            }
        }
        else if (fieldName == kCommitTimestampFieldName) {
            if (MONGO_likely(ctxt.checkAndAssertType(element, bsonTimestamp))) {
                if (MONGO_unlikely(usedFields[kCommitTimestampBit])) {
                    ctxt.throwDuplicateField(element);
                }

                usedFields.set(kCommitTimestampBit);

                _hasCommitTimestamp = true;
                _commitTimestamp = element.timestamp();
            }
        }
        else {
            ctxt.throwUnknownField(fieldName);
        }
    }

    if (MONGO_unlikely(!usedFields.all())) {
        if (!usedFields[kCommitTransactionBit]) {
            _commitTransaction = 1;
        }
        if (!usedFields[kCommitTimestampBit]) {
            ctxt.throwMissingField(kCommitTimestampFieldName);
        }
    }

}


void CommitTransactionOplogObject::serialize(BSONObjBuilder* builder) const {
    invariant(_hasCommitTimestamp);

    builder->append(kCommitTransactionFieldName, _commitTransaction);

    builder->append(kCommitTimestampFieldName, _commitTimestamp);

}


BSONObj CommitTransactionOplogObject::toBSON() const {
    BSONObjBuilder builder;
    serialize(&builder);
    return builder.obj();
}

constexpr StringData AbortTransactionOplogObject::kAbortTransactionFieldName;


AbortTransactionOplogObject::AbortTransactionOplogObject()  {
    // Used for initialization only
}


AbortTransactionOplogObject AbortTransactionOplogObject::parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    AbortTransactionOplogObject object;
    object.parseProtected(ctxt, bsonObject);
    return object;
}
void AbortTransactionOplogObject::parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    std::bitset<1> usedFields;
    const size_t kAbortTransactionBit = 0;

    for (const auto& element :bsonObject) {
        const auto fieldName = element.fieldNameStringData();


        if (fieldName == kAbortTransactionFieldName) {
            if (MONGO_likely(ctxt.checkAndAssertType(element, NumberInt))) {
                if (MONGO_unlikely(usedFields[kAbortTransactionBit])) {
                    ctxt.throwDuplicateField(element);
                }

                usedFields.set(kAbortTransactionBit);

                _abortTransaction = element._numberInt();
            }
        }
        else {
            ctxt.throwUnknownField(fieldName);
        }
    }

    if (MONGO_unlikely(!usedFields.all())) {
        if (!usedFields[kAbortTransactionBit]) {
            _abortTransaction = 1;
        }
    }

}


void AbortTransactionOplogObject::serialize(BSONObjBuilder* builder) const {
    builder->append(kAbortTransactionFieldName, _abortTransaction);

}


BSONObj AbortTransactionOplogObject::toBSON() const {
    BSONObjBuilder builder;
    serialize(&builder);
    return builder.obj();
}

constexpr StringData CommitTransaction::kCommitTimestampFieldName;
constexpr StringData CommitTransaction::kDbNameFieldName;
constexpr StringData CommitTransaction::kCommandName;

const std::vector<StringData> CommitTransaction::_knownFields {
    CommitTransaction::kCommitTimestampFieldName,
    CommitTransaction::kDbNameFieldName,
    CommitTransaction::kCommandName,
};

CommitTransaction::CommitTransaction() : _hasDbName(false) {
    // Used for initialization only
}


CommitTransaction CommitTransaction::parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    CommitTransaction object;
    object.parseProtected(ctxt, bsonObject);
    return object;
}
void CommitTransaction::parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    std::bitset<2> usedFields;
    const size_t kCommitTimestampBit = 0;
    const size_t kDbNameBit = 1;
    BSONElement commandElement;
    bool firstFieldFound = false;

    for (const auto& element :bsonObject) {
        const auto fieldName = element.fieldNameStringData();

        if (firstFieldFound == false) {
            firstFieldFound = true;
            continue;
        }

        if (fieldName == kCommitTimestampFieldName) {
            if (MONGO_likely(ctxt.checkAndAssertType(element, bsonTimestamp))) {
                if (MONGO_unlikely(usedFields[kCommitTimestampBit])) {
                    ctxt.throwDuplicateField(element);
                }

                usedFields.set(kCommitTimestampBit);

                _commitTimestamp = element.timestamp();
            }
        }
        else if (fieldName == kDbNameFieldName) {
            if (MONGO_likely(ctxt.checkAndAssertType(element, String))) {
                if (MONGO_unlikely(usedFields[kDbNameBit])) {
                    ctxt.throwDuplicateField(element);
                }

                usedFields.set(kDbNameBit);

                _hasDbName = true;
                _dbName = element.str();
            }
        }
        else {
            if (!mongo::isGenericArgument(fieldName)) {
                ctxt.throwUnknownField(fieldName);
            }
        }
    }

    if (MONGO_unlikely(!usedFields.all())) {
        if (!usedFields[kDbNameBit]) {
            ctxt.throwMissingField(kDbNameFieldName);
        }
    }

}

CommitTransaction CommitTransaction::parse(const IDLParserErrorContext& ctxt, const OpMsgRequest& request) {
    CommitTransaction object;
    object.parseProtected(ctxt, request);
    return object;
}
void CommitTransaction::parseProtected(const IDLParserErrorContext& ctxt, const OpMsgRequest& request) {
    std::bitset<2> usedFields;
    const size_t kCommitTimestampBit = 0;
    const size_t kDbNameBit = 1;
    BSONElement commandElement;
    bool firstFieldFound = false;

    for (const auto& element :request.body) {
        const auto fieldName = element.fieldNameStringData();

        if (firstFieldFound == false) {
            firstFieldFound = true;
            continue;
        }

        if (fieldName == kCommitTimestampFieldName) {
            if (MONGO_likely(ctxt.checkAndAssertType(element, bsonTimestamp))) {
                if (MONGO_unlikely(usedFields[kCommitTimestampBit])) {
                    ctxt.throwDuplicateField(element);
                }

                usedFields.set(kCommitTimestampBit);

                _commitTimestamp = element.timestamp();
            }
        }
        else if (fieldName == kDbNameFieldName) {
            if (MONGO_likely(ctxt.checkAndAssertType(element, String))) {
                if (MONGO_unlikely(usedFields[kDbNameBit])) {
                    ctxt.throwDuplicateField(element);
                }

                usedFields.set(kDbNameBit);

                _hasDbName = true;
                _dbName = element.str();
            }
        }
        else {
            if (!mongo::isGenericArgument(fieldName)) {
                ctxt.throwUnknownField(fieldName);
            }
        }
    }

    if (MONGO_unlikely(!usedFields.all())) {
        if (!usedFields[kDbNameBit]) {
            ctxt.throwMissingField(kDbNameFieldName);
        }
    }

}

void CommitTransaction::serialize(const BSONObj& commandPassthroughFields, BSONObjBuilder* builder) const {
    invariant(_hasDbName);

    builder->append("commitTransaction", 1);
    if (_commitTimestamp.is_initialized()) {
        builder->append(kCommitTimestampFieldName, _commitTimestamp.get());
    }

    IDLParserErrorContext::appendGenericCommandArguments(commandPassthroughFields, _knownFields, builder);

}

OpMsgRequest CommitTransaction::serialize(const BSONObj& commandPassthroughFields) const {
    BSONObjBuilder localBuilder;
    {
        BSONObjBuilder* builder = &localBuilder;
        invariant(_hasDbName);

        builder->append("commitTransaction", 1);
        if (_commitTimestamp.is_initialized()) {
            builder->append(kCommitTimestampFieldName, _commitTimestamp.get());
        }

        builder->append(kDbNameFieldName, _dbName);

        IDLParserErrorContext::appendGenericCommandArguments(commandPassthroughFields, _knownFields, builder);

    }
    OpMsgRequest request;
    request.body = localBuilder.obj();
    return request;
}

BSONObj CommitTransaction::toBSON(const BSONObj& commandPassthroughFields) const {
    BSONObjBuilder builder;
    serialize(commandPassthroughFields, &builder);
    return builder.obj();
}

}  // namespace mongo
