/**
 * WARNING: This is a generated file. Do not modify.
 *
 * Source: buildscripts/idl/idlc.py --include src --base_dir build/mageia --target_arch i386 --header build/mageia/mongo/db/commands/txn_cmds_gen.h --output build/mageia/mongo/db/commands/txn_cmds_gen.cpp src/mongo/db/commands/txn_cmds.idl
 */

#pragma once

#include <algorithm>
#include <boost/optional.hpp>
#include <cstdint>
#include <string>
#include <tuple>
#include <vector>

#include "mongo/base/data_range.h"
#include "mongo/base/string_data.h"
#include "mongo/bson/bsonobj.h"
#include "mongo/bson/bsonobjbuilder.h"
#include "mongo/db/namespace_string.h"
#include "mongo/idl/idl_parser.h"
#include "mongo/rpc/op_msg.h"
#include "mongo/util/uuid.h"

namespace mongo {

/**
 * A document representing the 'o' field of a 'commitTransaction' oplog entry.
 */
class CommitTransactionOplogObject {
public:
    static constexpr auto kCommitTimestampFieldName = "commitTimestamp"_sd;
    static constexpr auto kCommitTransactionFieldName = "commitTransaction"_sd;

    CommitTransactionOplogObject();
    CommitTransactionOplogObject(mongo::Timestamp commitTimestamp);

    static CommitTransactionOplogObject parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    void serialize(BSONObjBuilder* builder) const;
    BSONObj toBSON() const;

    std::int32_t getCommitTransaction() const { return _commitTransaction; }
    Status validateCommitTransaction(std::int32_t) { return Status::OK(); }

    void setCommitTransaction(std::int32_t value) & {  _commitTransaction = std::move(value);  }

    /**
     * Specifies the timestamp at which the multi-document transaction should be committed.
     */
    const mongo::Timestamp& getCommitTimestamp() const { return _commitTimestamp; }
    Status validateCommitTimestamp(mongo::Timestamp) { return Status::OK(); }

    void setCommitTimestamp(mongo::Timestamp value) & {  _commitTimestamp = std::move(value); _hasCommitTimestamp = true; }

protected:
    void parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);

private:
    std::int32_t _commitTransaction{1};
    mongo::Timestamp _commitTimestamp;
    bool _hasCommitTimestamp : 1;
};

/**
 * A document representing the 'o' field of an 'abortTransaction' oplog entry.
 */
class AbortTransactionOplogObject {
public:
    static constexpr auto kAbortTransactionFieldName = "abortTransaction"_sd;

    AbortTransactionOplogObject();

    static AbortTransactionOplogObject parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    void serialize(BSONObjBuilder* builder) const;
    BSONObj toBSON() const;

    std::int32_t getAbortTransaction() const { return _abortTransaction; }
    Status validateAbortTransaction(std::int32_t) { return Status::OK(); }

    void setAbortTransaction(std::int32_t value) & {  _abortTransaction = std::move(value);  }

protected:
    void parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);

private:
    std::int32_t _abortTransaction{1};
};

/**
 * commitTransaction Command
 */
class CommitTransaction {
public:
    static constexpr auto kCommitTimestampFieldName = "commitTimestamp"_sd;
    static constexpr auto kDbNameFieldName = "$db"_sd;
    static constexpr auto kCommandName = "commitTransaction"_sd;

    CommitTransaction();

    static CommitTransaction parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    static CommitTransaction parse(const IDLParserErrorContext& ctxt, const OpMsgRequest& request);
    void serialize(const BSONObj& commandPassthroughFields, BSONObjBuilder* builder) const;
    OpMsgRequest serialize(const BSONObj& commandPassthroughFields) const;
    BSONObj toBSON(const BSONObj& commandPassthroughFields) const;


    /**
     * Timestamp at which to commit the transaction. Required for prepared transactions and illegal for non-prepared ones.
     */
    const boost::optional<mongo::Timestamp>& getCommitTimestamp() const& { return _commitTimestamp; }
    void getCommitTimestamp() && = delete;
    Status validateCommitTimestamp(boost::optional<mongo::Timestamp>) { return Status::OK(); }

    void setCommitTimestamp(boost::optional<mongo::Timestamp> value) & {  _commitTimestamp = std::move(value);  }

    const StringData getDbName() const& { return _dbName; }
    void getDbName() && = delete;
    Status validateDbName(StringData) { return Status::OK(); }

    void setDbName(StringData value) & {  _dbName = value.toString(); _hasDbName = true; }

protected:
    void parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    void parseProtected(const IDLParserErrorContext& ctxt, const OpMsgRequest& request);

private:
    static const std::vector<StringData> _knownFields;



    boost::optional<mongo::Timestamp> _commitTimestamp;
    std::string _dbName;
    bool _hasDbName : 1;
};

}  // namespace mongo
