/**
 * WARNING: This is a generated file. Do not modify.
 *
 * Source: buildscripts/idl/idlc.py --include src --base_dir build/mageia --target_arch i386 --header build/mageia/mongo/db/commands/txn_two_phase_commit_cmds_gen.h --output build/mageia/mongo/db/commands/txn_two_phase_commit_cmds_gen.cpp src/mongo/db/commands/txn_two_phase_commit_cmds.idl
 */

#pragma once

#include <algorithm>
#include <boost/optional.hpp>
#include <cstdint>
#include <string>
#include <tuple>
#include <vector>

#include "mongo/base/data_range.h"
#include "mongo/base/string_data.h"
#include "mongo/bson/bsonobj.h"
#include "mongo/bson/bsonobjbuilder.h"
#include "mongo/db/namespace_string.h"
#include "mongo/idl/idl_parser.h"
#include "mongo/rpc/op_msg.h"
#include "mongo/s/shard_id.h"
#include "mongo/util/uuid.h"

namespace mongo {

/**
 * Describes a shard participant in a transaction commit
 */
class CommitParticipant {
public:
    static constexpr auto kShardIdFieldName = "shardId"_sd;

    CommitParticipant();
    CommitParticipant(mongo::ShardId shardId);

    static CommitParticipant parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    void serialize(BSONObjBuilder* builder) const;
    BSONObj toBSON() const;

    /**
     * The id of the shard
     */
    const mongo::ShardId& getShardId() const { return _shardId; }
    Status validateShardId(mongo::ShardId) { return Status::OK(); }

    void setShardId(mongo::ShardId value) & {  _shardId = std::move(value); _hasShardId = true; }

protected:
    void parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);

private:
    mongo::ShardId _shardId;
    bool _hasShardId : 1;
};

/**
 * Parser for the 'prepareTransaction' command.
 */
class PrepareTransaction {
public:
    static constexpr auto kCoordinatorIdFieldName = "coordinatorId"_sd;
    static constexpr auto kDbNameFieldName = "$db"_sd;
    static constexpr auto kCommandName = "prepareTransaction"_sd;

    PrepareTransaction();
    PrepareTransaction(mongo::ShardId coordinatorId);

    static PrepareTransaction parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    static PrepareTransaction parse(const IDLParserErrorContext& ctxt, const OpMsgRequest& request);
    void serialize(const BSONObj& commandPassthroughFields, BSONObjBuilder* builder) const;
    OpMsgRequest serialize(const BSONObj& commandPassthroughFields) const;
    BSONObj toBSON(const BSONObj& commandPassthroughFields) const;


    /**
     * The coordinator shard for this transaction.
     */
    const mongo::ShardId& getCoordinatorId() const { return _coordinatorId; }
    Status validateCoordinatorId(mongo::ShardId) { return Status::OK(); }

    void setCoordinatorId(mongo::ShardId value) & {  _coordinatorId = std::move(value); _hasCoordinatorId = true; }

    const StringData getDbName() const& { return _dbName; }
    void getDbName() && = delete;
    Status validateDbName(StringData) { return Status::OK(); }

    void setDbName(StringData value) & {  _dbName = value.toString(); _hasDbName = true; }

protected:
    void parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    void parseProtected(const IDLParserErrorContext& ctxt, const OpMsgRequest& request);

private:
    static const std::vector<StringData> _knownFields;



    mongo::ShardId _coordinatorId;
    std::string _dbName;
    bool _hasCoordinatorId : 1;
    bool _hasDbName : 1;
};

/**
 * Parser for the 'voteCommitTransaction' command.
 */
class VoteCommitTransaction {
public:
    static constexpr auto kDbNameFieldName = "$db"_sd;
    static constexpr auto kPrepareTimestampFieldName = "prepareTimestamp"_sd;
    static constexpr auto kShardIdFieldName = "shardId"_sd;
    static constexpr auto kCommandName = "voteCommitTransaction"_sd;

    VoteCommitTransaction();
    VoteCommitTransaction(mongo::ShardId shardId, mongo::Timestamp prepareTimestamp);

    static VoteCommitTransaction parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    static VoteCommitTransaction parse(const IDLParserErrorContext& ctxt, const OpMsgRequest& request);
    void serialize(const BSONObj& commandPassthroughFields, BSONObjBuilder* builder) const;
    OpMsgRequest serialize(const BSONObj& commandPassthroughFields) const;
    BSONObj toBSON(const BSONObj& commandPassthroughFields) const;


    /**
     * The shard name of the sender
     */
    const mongo::ShardId& getShardId() const { return _shardId; }
    Status validateShardId(mongo::ShardId) { return Status::OK(); }

    void setShardId(mongo::ShardId value) & {  _shardId = std::move(value); _hasShardId = true; }

    /**
     * Timestamp at which the sender prepared the transaction
     */
    const mongo::Timestamp& getPrepareTimestamp() const { return _prepareTimestamp; }
    Status validatePrepareTimestamp(mongo::Timestamp) { return Status::OK(); }

    void setPrepareTimestamp(mongo::Timestamp value) & {  _prepareTimestamp = std::move(value); _hasPrepareTimestamp = true; }

    const StringData getDbName() const& { return _dbName; }
    void getDbName() && = delete;
    Status validateDbName(StringData) { return Status::OK(); }

    void setDbName(StringData value) & {  _dbName = value.toString(); _hasDbName = true; }

protected:
    void parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    void parseProtected(const IDLParserErrorContext& ctxt, const OpMsgRequest& request);

private:
    static const std::vector<StringData> _knownFields;



    mongo::ShardId _shardId;
    mongo::Timestamp _prepareTimestamp;
    std::string _dbName;
    bool _hasShardId : 1;
    bool _hasPrepareTimestamp : 1;
    bool _hasDbName : 1;
};

/**
 * Parser for the 'voteAbortTransaction' command.
 */
class VoteAbortTransaction {
public:
    static constexpr auto kDbNameFieldName = "$db"_sd;
    static constexpr auto kShardIdFieldName = "shardId"_sd;
    static constexpr auto kCommandName = "voteAbortTransaction"_sd;

    VoteAbortTransaction();
    VoteAbortTransaction(mongo::ShardId shardId);

    static VoteAbortTransaction parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    static VoteAbortTransaction parse(const IDLParserErrorContext& ctxt, const OpMsgRequest& request);
    void serialize(const BSONObj& commandPassthroughFields, BSONObjBuilder* builder) const;
    OpMsgRequest serialize(const BSONObj& commandPassthroughFields) const;
    BSONObj toBSON(const BSONObj& commandPassthroughFields) const;


    /**
     * The shard name of the sender
     */
    const mongo::ShardId& getShardId() const { return _shardId; }
    Status validateShardId(mongo::ShardId) { return Status::OK(); }

    void setShardId(mongo::ShardId value) & {  _shardId = std::move(value); _hasShardId = true; }

    const StringData getDbName() const& { return _dbName; }
    void getDbName() && = delete;
    Status validateDbName(StringData) { return Status::OK(); }

    void setDbName(StringData value) & {  _dbName = value.toString(); _hasDbName = true; }

protected:
    void parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    void parseProtected(const IDLParserErrorContext& ctxt, const OpMsgRequest& request);

private:
    static const std::vector<StringData> _knownFields;



    mongo::ShardId _shardId;
    std::string _dbName;
    bool _hasShardId : 1;
    bool _hasDbName : 1;
};

/**
 * Parser for the 'coordinateCommitTransaction' command.
 */
class CoordinateCommitTransaction {
public:
    static constexpr auto kDbNameFieldName = "$db"_sd;
    static constexpr auto kParticipantsFieldName = "participants"_sd;
    static constexpr auto kCommandName = "coordinateCommitTransaction"_sd;

    CoordinateCommitTransaction();
    CoordinateCommitTransaction(std::vector<mongo::CommitParticipant> participants);

    static CoordinateCommitTransaction parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    static CoordinateCommitTransaction parse(const IDLParserErrorContext& ctxt, const OpMsgRequest& request);
    void serialize(const BSONObj& commandPassthroughFields, BSONObjBuilder* builder) const;
    OpMsgRequest serialize(const BSONObj& commandPassthroughFields) const;
    BSONObj toBSON(const BSONObj& commandPassthroughFields) const;


    /**
     * An array of shard participants that must be included in the commit.
     */
    const std::vector<mongo::CommitParticipant>& getParticipants() const& { return _participants; }
    void getParticipants() && = delete;
    Status validateParticipants(std::vector<mongo::CommitParticipant>) { return Status::OK(); }

    void setParticipants(std::vector<mongo::CommitParticipant> value) & {  _participants = std::move(value); _hasParticipants = true; }

    const StringData getDbName() const& { return _dbName; }
    void getDbName() && = delete;
    Status validateDbName(StringData) { return Status::OK(); }

    void setDbName(StringData value) & {  _dbName = value.toString(); _hasDbName = true; }

protected:
    void parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    void parseProtected(const IDLParserErrorContext& ctxt, const OpMsgRequest& request);

private:
    static const std::vector<StringData> _knownFields;



    std::vector<mongo::CommitParticipant> _participants;
    std::string _dbName;
    bool _hasParticipants : 1;
    bool _hasDbName : 1;
};

}  // namespace mongo
