/**
 * WARNING: This is a generated file. Do not modify.
 *
 * Source: buildscripts/idl/idlc.py --include src --base_dir build/mageia --target_arch i386 --header build/mageia/mongo/db/free_mon/free_mon_storage_gen.h --output build/mageia/mongo/db/free_mon/free_mon_storage_gen.cpp src/mongo/db/free_mon/free_mon_storage.idl
 */

#pragma once

#include <algorithm>
#include <boost/optional.hpp>
#include <cstdint>
#include <string>
#include <tuple>
#include <vector>

#include "mongo/base/data_range.h"
#include "mongo/base/string_data.h"
#include "mongo/bson/bsonobj.h"
#include "mongo/bson/bsonobjbuilder.h"
#include "mongo/db/namespace_string.h"
#include "mongo/idl/idl_parser.h"
#include "mongo/rpc/op_msg.h"
#include "mongo/util/uuid.h"

namespace mongo {

/**
 * Action types
 */
enum class StorageStateEnum : std::int32_t {
    disabled ,
    enabled ,
    pending ,
};

StorageStateEnum StorageState_parse(const IDLParserErrorContext& ctxt, StringData value);
StringData StorageState_serializer(StorageStateEnum value);

/**
 * Persisted document in admin.system.version
 */
class FreeMonStorageState {
public:
    static constexpr auto k_idFieldName = "_id"_sd;
    static constexpr auto kInformationalURLFieldName = "informationalURL"_sd;
    static constexpr auto kMessageFieldName = "message"_sd;
    static constexpr auto kRegistrationIdFieldName = "registrationId"_sd;
    static constexpr auto kStateFieldName = "state"_sd;
    static constexpr auto kUserReminderFieldName = "userReminder"_sd;
    static constexpr auto kVersionFieldName = "version"_sd;

    FreeMonStorageState();
    FreeMonStorageState(std::int64_t version, std::string registrationId, std::string informationalURL, std::string message, std::string userReminder);

    static FreeMonStorageState parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    void serialize(BSONObjBuilder* builder) const;
    BSONObj toBSON() const;

    /**
     * Key of the Free Monitoring singleton document
     */
    const StringData get_id() const& { return __id; }
    void get_id() && = delete;
    Status validate_id(StringData) { return Status::OK(); }

    void set_id(StringData value) & {  __id = value.toString();  }

    /**
     * Storage version, initial version is 1
     */
    std::int64_t getVersion() const { return _version; }
    Status validateVersion(std::int64_t) { return Status::OK(); }

    void setVersion(std::int64_t value) & {  _version = std::move(value); _hasVersion = true; }

    /**
     * Indicates whether it is disabled or enabled
     */
    mongo::StorageStateEnum getState() const { return _state; }
    Status validateState(mongo::StorageStateEnum) { return Status::OK(); }

    void setState(mongo::StorageStateEnum value) & {  _state = std::move(value);  }

    /**
     * Registration Id
     */
    const StringData getRegistrationId() const& { return _registrationId; }
    void getRegistrationId() && = delete;
    Status validateRegistrationId(StringData) { return Status::OK(); }

    void setRegistrationId(StringData value) & {  _registrationId = value.toString(); _hasRegistrationId = true; }

    /**
     * Informational HTTP web page for metrics
     */
    const StringData getInformationalURL() const& { return _informationalURL; }
    void getInformationalURL() && = delete;
    Status validateInformationalURL(StringData) { return Status::OK(); }

    void setInformationalURL(StringData value) & {  _informationalURL = value.toString(); _hasInformationalURL = true; }

    /**
     * Informational message for shell to display to user
     */
    const StringData getMessage() const& { return _message; }
    void getMessage() && = delete;
    Status validateMessage(StringData) { return Status::OK(); }

    void setMessage(StringData value) & {  _message = value.toString(); _hasMessage = true; }

    /**
     * Message to display to user to remind them about service
     */
    const StringData getUserReminder() const& { return _userReminder; }
    void getUserReminder() && = delete;
    Status validateUserReminder(StringData) { return Status::OK(); }

    void setUserReminder(StringData value) & {  _userReminder = value.toString(); _hasUserReminder = true; }

    auto relationalTie() const {
        return std::tie(__id, _version, _state, _registrationId, _informationalURL, _message, _userReminder);
    }

    friend bool operator==(const FreeMonStorageState& left, const FreeMonStorageState& right) {
        return left.relationalTie() == right.relationalTie();
    }

    friend bool operator!=(const FreeMonStorageState& left, const FreeMonStorageState& right) {
        return left.relationalTie() != right.relationalTie();
    }

    friend bool operator<(const FreeMonStorageState& left, const FreeMonStorageState& right) {
        return left.relationalTie() < right.relationalTie();
    }

    friend bool operator>(const FreeMonStorageState& left, const FreeMonStorageState& right) {
        return left.relationalTie() > right.relationalTie();
    }

    friend bool operator<=(const FreeMonStorageState& left, const FreeMonStorageState& right) {
        return left.relationalTie() <= right.relationalTie();
    }

    friend bool operator>=(const FreeMonStorageState& left, const FreeMonStorageState& right) {
        return left.relationalTie() >= right.relationalTie();
    }

protected:
    void parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);

private:
    std::string __id{"free_monitoring"};
    std::int64_t _version;
    mongo::StorageStateEnum _state{mongo::StorageStateEnum::disabled};
    std::string _registrationId;
    std::string _informationalURL;
    std::string _message;
    std::string _userReminder;
    bool _hasVersion : 1;
    bool _hasRegistrationId : 1;
    bool _hasInformationalURL : 1;
    bool _hasMessage : 1;
    bool _hasUserReminder : 1;
};

}  // namespace mongo
