/**
 * WARNING: This is a generated file. Do not modify.
 *
 * Source: buildscripts/idl/idlc.py --include src --base_dir build/mageia --target_arch i386 --header build/mageia/mongo/db/pipeline/document_source_change_stream_gen.h --output build/mageia/mongo/db/pipeline/document_source_change_stream_gen.cpp src/mongo/db/pipeline/document_source_change_stream.idl
 */

#pragma once

#include <algorithm>
#include <boost/optional.hpp>
#include <cstdint>
#include <string>
#include <tuple>
#include <vector>

#include "mongo/base/data_range.h"
#include "mongo/base/string_data.h"
#include "mongo/bson/bsonobj.h"
#include "mongo/bson/bsonobjbuilder.h"
#include "mongo/db/namespace_string.h"
#include "mongo/db/pipeline/resume_token.h"
#include "mongo/idl/idl_parser.h"
#include "mongo/rpc/op_msg.h"
#include "mongo/util/uuid.h"

namespace mongo {

/**
 * The IDL type of cluster time
 */
class ResumeTokenClusterTime {
public:
    static constexpr auto kTimestampFieldName = "ts"_sd;

    ResumeTokenClusterTime();
    ResumeTokenClusterTime(mongo::Timestamp timestamp);

    static ResumeTokenClusterTime parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    void serialize(BSONObjBuilder* builder) const;
    BSONObj toBSON() const;

    /**
     * The timestamp of the logical time
     */
    const mongo::Timestamp& getTimestamp() const { return _timestamp; }
    Status validateTimestamp(mongo::Timestamp) { return Status::OK(); }

    void setTimestamp(mongo::Timestamp value) & {  _timestamp = std::move(value); _hasTimestamp = true; }

protected:
    void parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);

private:
    mongo::Timestamp _timestamp;
    bool _hasTimestamp : 1;
};

/**
 * A document used to specify the $changeStream stage of an aggregation pipeline.
 */
class DocumentSourceChangeStreamSpec {
public:
    static constexpr auto kAllChangesForClusterFieldName = "allChangesForCluster"_sd;
    static constexpr auto kFullDocumentFieldName = "fullDocument"_sd;
    static constexpr auto kResumeAfterFieldName = "resumeAfter"_sd;
    static constexpr auto kStartAfterFieldName = "startAfter"_sd;
    static constexpr auto kStartAtOperationTimeFieldName = "startAtOperationTime"_sd;

    DocumentSourceChangeStreamSpec();

    static DocumentSourceChangeStreamSpec parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    void serialize(BSONObjBuilder* builder) const;
    BSONObj toBSON() const;

    /**
     * An object representing the point at which we should resume reporting changes from.
     */
    const boost::optional<mongo::ResumeToken>& getResumeAfter() const& { return _resumeAfter; }
    void getResumeAfter() && = delete;
    Status validateResumeAfter(boost::optional<mongo::ResumeToken>) { return Status::OK(); }

    void setResumeAfter(boost::optional<mongo::ResumeToken> value) & {  _resumeAfter = std::move(value);  }

    /**
     * An object representing the point at which we should start reporting changes from. This is allowed to be a token from an invalidating command.
     */
    const boost::optional<mongo::ResumeToken>& getStartAfter() const& { return _startAfter; }
    void getStartAfter() && = delete;
    Status validateStartAfter(boost::optional<mongo::ResumeToken>) { return Status::OK(); }

    void setStartAfter(boost::optional<mongo::ResumeToken> value) & {  _startAfter = std::move(value);  }

    /**
     * The operation time after which we should start reporting changes. Only one of resumeAfter, _resumeAfterClusterTimeDeprecated, and startAtOperationTime should be specified.
     */
    const boost::optional<mongo::Timestamp>& getStartAtOperationTime() const& { return _startAtOperationTime; }
    void getStartAtOperationTime() && = delete;
    Status validateStartAtOperationTime(boost::optional<mongo::Timestamp>) { return Status::OK(); }

    void setStartAtOperationTime(boost::optional<mongo::Timestamp> value) & {  _startAtOperationTime = std::move(value);  }

    /**
     * A string '"updateLookup"' or '"default"', indicating whether or not we should return a full document or just changes for an update.
     */
    const StringData getFullDocument() const& { return _fullDocument; }
    void getFullDocument() && = delete;
    Status validateFullDocument(StringData) { return Status::OK(); }

    void setFullDocument(StringData value) & {  _fullDocument = value.toString();  }

    /**
     * A flag indicating whether the stream should report all changes that occur on the deployment, aside from those on internal databases or collections.
     */
    bool getAllChangesForCluster() const { return _allChangesForCluster; }
    Status validateAllChangesForCluster(bool) { return Status::OK(); }

    void setAllChangesForCluster(bool value) & {  _allChangesForCluster = std::move(value);  }

protected:
    void parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);

private:
    boost::optional<mongo::ResumeToken> _resumeAfter;
    boost::optional<mongo::ResumeToken> _startAfter;
    boost::optional<mongo::Timestamp> _startAtOperationTime;
    std::string _fullDocument{"default"};
    bool _allChangesForCluster{false};
};

}  // namespace mongo
