/**
 * WARNING: This is a generated file. Do not modify.
 *
 * Source: buildscripts/idl/idlc.py --include src --base_dir build/mageia --target_arch i386 --header build/mageia/mongo/db/pipeline/document_source_out_gen.h --output build/mageia/mongo/db/pipeline/document_source_out_gen.cpp src/mongo/db/pipeline/document_source_out.idl
 */

#include "mongo/platform/basic.h"

#include "mongo/db/pipeline/document_source_out_gen.h"

#include <bitset>
#include <set>

#include "mongo/bson/bsonobjbuilder.h"
#include "mongo/db/command_generic_argument.h"
#include "mongo/db/commands.h"

namespace mongo {

/**
 * Possible write mode values.
 */
namespace  {
constexpr StringData kWriteMode_kModeReplaceCollection = "replaceCollection"_sd;
constexpr StringData kWriteMode_kModeInsertDocuments = "insertDocuments"_sd;
constexpr StringData kWriteMode_kModeReplaceDocuments = "replaceDocuments"_sd;
}  // namespace 

WriteModeEnum WriteMode_parse(const IDLParserErrorContext& ctxt, StringData value) {
    if (value == kWriteMode_kModeReplaceCollection) {
        return WriteModeEnum::kModeReplaceCollection;
    }
    if (value == kWriteMode_kModeInsertDocuments) {
        return WriteModeEnum::kModeInsertDocuments;
    }
    if (value == kWriteMode_kModeReplaceDocuments) {
        return WriteModeEnum::kModeReplaceDocuments;
    }
    ctxt.throwBadEnumValue(value);
}

StringData WriteMode_serializer(WriteModeEnum value) {
    if (value == WriteModeEnum::kModeReplaceCollection) {
        return kWriteMode_kModeReplaceCollection;
    }
    if (value == WriteModeEnum::kModeInsertDocuments) {
        return kWriteMode_kModeInsertDocuments;
    }
    if (value == WriteModeEnum::kModeReplaceDocuments) {
        return kWriteMode_kModeReplaceDocuments;
    }
    MONGO_UNREACHABLE;
    return StringData();
}

constexpr StringData DocumentSourceOutSpec::kModeFieldName;
constexpr StringData DocumentSourceOutSpec::kTargetCollectionFieldName;
constexpr StringData DocumentSourceOutSpec::kTargetDbFieldName;
constexpr StringData DocumentSourceOutSpec::kUniqueKeyFieldName;


DocumentSourceOutSpec::DocumentSourceOutSpec() : _hasTargetCollection(false), _hasMode(false) {
    // Used for initialization only
}
DocumentSourceOutSpec::DocumentSourceOutSpec(std::string targetCollection, mongo::WriteModeEnum mode) : _targetCollection(std::move(targetCollection)), _mode(std::move(mode)), _hasTargetCollection(true), _hasMode(true) {
    // Used for initialization only
}


DocumentSourceOutSpec DocumentSourceOutSpec::parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    DocumentSourceOutSpec object;
    object.parseProtected(ctxt, bsonObject);
    return object;
}
void DocumentSourceOutSpec::parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    std::bitset<4> usedFields;
    const size_t kTargetCollectionBit = 0;
    const size_t kTargetDbBit = 1;
    const size_t kModeBit = 2;
    const size_t kUniqueKeyBit = 3;

    for (const auto& element :bsonObject) {
        const auto fieldName = element.fieldNameStringData();


        if (fieldName == kTargetCollectionFieldName) {
            if (MONGO_likely(ctxt.checkAndAssertType(element, String))) {
                if (MONGO_unlikely(usedFields[kTargetCollectionBit])) {
                    ctxt.throwDuplicateField(element);
                }

                usedFields.set(kTargetCollectionBit);

                _hasTargetCollection = true;
                _targetCollection = element.str();
            }
        }
        else if (fieldName == kTargetDbFieldName) {
            if (MONGO_likely(ctxt.checkAndAssertType(element, String))) {
                if (MONGO_unlikely(usedFields[kTargetDbBit])) {
                    ctxt.throwDuplicateField(element);
                }

                usedFields.set(kTargetDbBit);

                _targetDb = element.str();
            }
        }
        else if (fieldName == kModeFieldName) {
            if (MONGO_likely(ctxt.checkAndAssertType(element, String))) {
                if (MONGO_unlikely(usedFields[kModeBit])) {
                    ctxt.throwDuplicateField(element);
                }

                usedFields.set(kModeBit);

                _hasMode = true;
                IDLParserErrorContext tempContext(kModeFieldName, &ctxt);
                _mode = WriteMode_parse(tempContext, element.valueStringData());
            }
        }
        else if (fieldName == kUniqueKeyFieldName) {
            if (MONGO_likely(ctxt.checkAndAssertType(element, Object))) {
                if (MONGO_unlikely(usedFields[kUniqueKeyBit])) {
                    ctxt.throwDuplicateField(element);
                }

                usedFields.set(kUniqueKeyBit);

                _uniqueKey = element.Obj();
            }
        }
        else {
            ctxt.throwUnknownField(fieldName);
        }
    }

    if (MONGO_unlikely(!usedFields.all())) {
        if (!usedFields[kTargetCollectionBit]) {
            ctxt.throwMissingField(kTargetCollectionFieldName);
        }
        if (!usedFields[kModeBit]) {
            ctxt.throwMissingField(kModeFieldName);
        }
    }

}


void DocumentSourceOutSpec::serialize(BSONObjBuilder* builder) const {
    invariant(_hasTargetCollection && _hasMode);

    builder->append(kTargetCollectionFieldName, _targetCollection);

    if (_targetDb.is_initialized()) {
        builder->append(kTargetDbFieldName, _targetDb.get());
    }

    {
        builder->append(kModeFieldName, WriteMode_serializer(_mode));
    }

    if (_uniqueKey.is_initialized()) {
        builder->append(kUniqueKeyFieldName, _uniqueKey.get());
    }

}


BSONObj DocumentSourceOutSpec::toBSON() const {
    BSONObjBuilder builder;
    serialize(&builder);
    return builder.obj();
}

}  // namespace mongo
