/**
 * WARNING: This is a generated file. Do not modify.
 *
 * Source: buildscripts/idl/idlc.py --include src --base_dir build/mageia --target_arch i386 --header build/mageia/mongo/db/pipeline/document_source_out_gen.h --output build/mageia/mongo/db/pipeline/document_source_out_gen.cpp src/mongo/db/pipeline/document_source_out.idl
 */

#pragma once

#include <algorithm>
#include <boost/optional.hpp>
#include <cstdint>
#include <string>
#include <tuple>
#include <vector>

#include "mongo/base/data_range.h"
#include "mongo/base/string_data.h"
#include "mongo/bson/bsonobj.h"
#include "mongo/bson/bsonobjbuilder.h"
#include "mongo/db/namespace_string.h"
#include "mongo/idl/idl_parser.h"
#include "mongo/rpc/op_msg.h"
#include "mongo/util/uuid.h"

namespace mongo {

/**
 * Possible write mode values.
 */
enum class WriteModeEnum : std::int32_t {
    kModeReplaceCollection ,
    kModeInsertDocuments ,
    kModeReplaceDocuments ,
};

WriteModeEnum WriteMode_parse(const IDLParserErrorContext& ctxt, StringData value);
StringData WriteMode_serializer(WriteModeEnum value);

/**
 * A document used to specify the $out stage of an aggregation pipeline.
 */
class DocumentSourceOutSpec {
public:
    static constexpr auto kModeFieldName = "mode"_sd;
    static constexpr auto kTargetCollectionFieldName = "to"_sd;
    static constexpr auto kTargetDbFieldName = "db"_sd;
    static constexpr auto kUniqueKeyFieldName = "uniqueKey"_sd;

    DocumentSourceOutSpec();
    DocumentSourceOutSpec(std::string targetCollection, mongo::WriteModeEnum mode);

    static DocumentSourceOutSpec parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    void serialize(BSONObjBuilder* builder) const;
    BSONObj toBSON() const;

    /**
     * Name of the target collection.
     */
    const StringData getTargetCollection() const& { return _targetCollection; }
    void getTargetCollection() && = delete;
    Status validateTargetCollection(StringData) { return Status::OK(); }

    void setTargetCollection(StringData value) & {  _targetCollection = value.toString(); _hasTargetCollection = true; }

    /**
     * Name of the target database, defaults to the database of the aggregation.
     */
    const boost::optional<StringData> getTargetDb() const& { return boost::optional<StringData>{_targetDb}; }
    void getTargetDb() && = delete;
    Status validateTargetDb(boost::optional<StringData>) { return Status::OK(); }

    void setTargetDb(boost::optional<StringData> value) & {  if (value.is_initialized()) {
        _targetDb = value.get().toString();
    } else {
        _targetDb = boost::none;
    }
      }

    /**
     * The write mode for the output operation.
     */
    mongo::WriteModeEnum getMode() const { return _mode; }
    Status validateMode(mongo::WriteModeEnum) { return Status::OK(); }

    void setMode(mongo::WriteModeEnum value) & {  _mode = std::move(value); _hasMode = true; }

    /**
     * Document of fields representing the unique key.
     */
    const boost::optional<mongo::BSONObj>& getUniqueKey() const& { return _uniqueKey; }
    void getUniqueKey() && = delete;
    Status validateUniqueKey(boost::optional<mongo::BSONObj>) { return Status::OK(); }

    void setUniqueKey(boost::optional<mongo::BSONObj> value) & {  _uniqueKey = std::move(value);  }

protected:
    void parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);

private:
    std::string _targetCollection;
    boost::optional<std::string> _targetDb;
    mongo::WriteModeEnum _mode;
    boost::optional<mongo::BSONObj> _uniqueKey;
    bool _hasTargetCollection : 1;
    bool _hasMode : 1;
};

}  // namespace mongo
