/**
 * WARNING: This is a generated file. Do not modify.
 *
 * Source: buildscripts/idl/idlc.py --include src --base_dir build/mageia --target_arch i386 --header build/mageia/mongo/db/transaction_commit_decision_gen.h --output build/mageia/mongo/db/transaction_commit_decision_gen.cpp src/mongo/db/transaction_commit_decision.idl
 */

#pragma once

#include <algorithm>
#include <boost/optional.hpp>
#include <cstdint>
#include <string>
#include <tuple>
#include <vector>

#include "mongo/base/data_range.h"
#include "mongo/base/string_data.h"
#include "mongo/bson/bsonobj.h"
#include "mongo/bson/bsonobjbuilder.h"
#include "mongo/crypto/sha256_block.h"
#include "mongo/db/logical_session_id.h"
#include "mongo/db/logical_session_id_gen.h"
#include "mongo/db/namespace_string.h"
#include "mongo/idl/idl_parser.h"
#include "mongo/rpc/op_msg.h"
#include "mongo/s/shard_id.h"
#include "mongo/util/uuid.h"

namespace mongo {

/**
 * A document used for storing the coordinator commit decision.
 */
class TransactionCommitDecision {
public:
    static constexpr auto k_idFieldName = "_id"_sd;
    static constexpr auto kCommitTimestampFieldName = "commitTimestamp"_sd;
    static constexpr auto kParticipantsFieldName = "participants"_sd;

    TransactionCommitDecision();
    TransactionCommitDecision(mongo::OperationSessionInfo _id, mongo::Timestamp commitTimestamp, std::vector<mongo::ShardId> participants);

    static TransactionCommitDecision parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    void serialize(BSONObjBuilder* builder) const;
    BSONObj toBSON() const;

    /**
     * The sessionId and txnNumber of this transaction.
     */
    const mongo::OperationSessionInfo& get_id() const { return __id; }
    mongo::OperationSessionInfo& get_id() { return __id; }
    Status validate_id(mongo::OperationSessionInfo) { return Status::OK(); }

    void set_id(mongo::OperationSessionInfo value) & {  __id = std::move(value); _has_id = true; }

    /**
     * The clusterTime at which the participants should make the transaction's writes visible.
     */
    const mongo::Timestamp& getCommitTimestamp() const { return _commitTimestamp; }
    Status validateCommitTimestamp(mongo::Timestamp) { return Status::OK(); }

    void setCommitTimestamp(mongo::Timestamp value) & {  _commitTimestamp = std::move(value); _hasCommitTimestamp = true; }

    /**
     * List of transaction participants.
     */
    const std::vector<mongo::ShardId>& getParticipants() const& { return _participants; }
    void getParticipants() && = delete;
    Status validateParticipants(std::vector<mongo::ShardId>) { return Status::OK(); }

    void setParticipants(std::vector<mongo::ShardId> value) & {  _participants = std::move(value); _hasParticipants = true; }

protected:
    void parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);

private:
    mongo::OperationSessionInfo __id;
    mongo::Timestamp _commitTimestamp;
    std::vector<mongo::ShardId> _participants;
    bool _has_id : 1;
    bool _hasCommitTimestamp : 1;
    bool _hasParticipants : 1;
};

}  // namespace mongo
