/**
 * WARNING: This is a generated file. Do not modify.
 *
 * Source: buildscripts/idl/idlc.py --include src --base_dir build/mageia --target_arch i386 --header build/mageia/mongo/db/transactions_stats_gen.h --output build/mageia/mongo/db/transactions_stats_gen.cpp src/mongo/db/transactions_stats.idl
 */

#pragma once

#include <algorithm>
#include <boost/optional.hpp>
#include <cstdint>
#include <string>
#include <tuple>
#include <vector>

#include "mongo/base/data_range.h"
#include "mongo/base/string_data.h"
#include "mongo/bson/bsonobj.h"
#include "mongo/bson/bsonobjbuilder.h"
#include "mongo/db/namespace_string.h"
#include "mongo/idl/idl_parser.h"
#include "mongo/rpc/op_msg.h"
#include "mongo/util/uuid.h"

namespace mongo {

/**
 * A struct representing the section of the server status command with information about transactions
 */
class TransactionsStats {
public:
    static constexpr auto kCurrentActiveFieldName = "currentActive"_sd;
    static constexpr auto kCurrentInactiveFieldName = "currentInactive"_sd;
    static constexpr auto kCurrentOpenFieldName = "currentOpen"_sd;
    static constexpr auto kRetriedCommandsCountFieldName = "retriedCommandsCount"_sd;
    static constexpr auto kRetriedStatementsCountFieldName = "retriedStatementsCount"_sd;
    static constexpr auto kTotalAbortedFieldName = "totalAborted"_sd;
    static constexpr auto kTotalCommittedFieldName = "totalCommitted"_sd;
    static constexpr auto kTotalStartedFieldName = "totalStarted"_sd;
    static constexpr auto kTransactionsCollectionWriteCountFieldName = "transactionsCollectionWriteCount"_sd;

    TransactionsStats();

    static TransactionsStats parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    void serialize(BSONObjBuilder* builder) const;
    BSONObj toBSON() const;

    std::int64_t getRetriedCommandsCount() const { return _retriedCommandsCount; }
    Status validateRetriedCommandsCount(std::int64_t) { return Status::OK(); }

    void setRetriedCommandsCount(std::int64_t value) & {  _retriedCommandsCount = std::move(value);  }

    std::int64_t getRetriedStatementsCount() const { return _retriedStatementsCount; }
    Status validateRetriedStatementsCount(std::int64_t) { return Status::OK(); }

    void setRetriedStatementsCount(std::int64_t value) & {  _retriedStatementsCount = std::move(value);  }

    std::int64_t getTransactionsCollectionWriteCount() const { return _transactionsCollectionWriteCount; }
    Status validateTransactionsCollectionWriteCount(std::int64_t) { return Status::OK(); }

    void setTransactionsCollectionWriteCount(std::int64_t value) & {  _transactionsCollectionWriteCount = std::move(value);  }

    std::int64_t getCurrentActive() const { return _currentActive; }
    Status validateCurrentActive(std::int64_t) { return Status::OK(); }

    void setCurrentActive(std::int64_t value) & {  _currentActive = std::move(value);  }

    std::int64_t getCurrentInactive() const { return _currentInactive; }
    Status validateCurrentInactive(std::int64_t) { return Status::OK(); }

    void setCurrentInactive(std::int64_t value) & {  _currentInactive = std::move(value);  }

    std::int64_t getCurrentOpen() const { return _currentOpen; }
    Status validateCurrentOpen(std::int64_t) { return Status::OK(); }

    void setCurrentOpen(std::int64_t value) & {  _currentOpen = std::move(value);  }

    std::int64_t getTotalAborted() const { return _totalAborted; }
    Status validateTotalAborted(std::int64_t) { return Status::OK(); }

    void setTotalAborted(std::int64_t value) & {  _totalAborted = std::move(value);  }

    std::int64_t getTotalCommitted() const { return _totalCommitted; }
    Status validateTotalCommitted(std::int64_t) { return Status::OK(); }

    void setTotalCommitted(std::int64_t value) & {  _totalCommitted = std::move(value);  }

    std::int64_t getTotalStarted() const { return _totalStarted; }
    Status validateTotalStarted(std::int64_t) { return Status::OK(); }

    void setTotalStarted(std::int64_t value) & {  _totalStarted = std::move(value);  }

protected:
    void parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);

private:
    std::int64_t _retriedCommandsCount{0};
    std::int64_t _retriedStatementsCount{0};
    std::int64_t _transactionsCollectionWriteCount{0};
    std::int64_t _currentActive{0};
    std::int64_t _currentInactive{0};
    std::int64_t _currentOpen{0};
    std::int64_t _totalAborted{0};
    std::int64_t _totalCommitted{0};
    std::int64_t _totalStarted{0};
};

}  // namespace mongo
